"""
This module contains the EventEncoder class
"""

from agentwire.core.events import BaseEvent

AGENTWIRE_MEDIA_TYPE = "application/vnd.agentwire.event+proto"

class EventEncoder:
    """
    Encodes Agent Wire events.
    """
    def __init__(self, accept: str = None):
        pass

    def get_content_type(self) -> str:
        """
        Returns the content type of the encoder.
        """
        return "text/event-stream"

    def encode(self, event: BaseEvent) -> str:
        """
        Encodes an event.
        """
        return self._encode_sse(event)

    def _encode_sse(self, event: BaseEvent) -> str:
        """
        Encodes an event into an SSE string.
        """
        return f"data: {event.model_dump_json(by_alias=True, exclude_none=True)}\n\n"
